<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Pre-Hire_Probation_Period_UnitObjectType StructType
 * @subpackage Structs
 */
class Pre_Hire_Probation_Period_UnitObjectType extends AbstractStructBase
{
    /**
     * The ID
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Pre_Hire_Probation_Period_UnitObjectIDType[]
     */
    public $ID;
    /**
     * The Descriptor
     * Meta information extracted from the WSDL
     * - documentation: Display information used to describe an instance of an object. This 'optional' information is for outbound descriptive purposes only and is not processed on inbound Workday Web Services requests.
     * @var string
     */
    public $Descriptor;
    /**
     * Constructor method for Pre-Hire_Probation_Period_UnitObjectType
     * @uses Pre_Hire_Probation_Period_UnitObjectType::setID()
     * @uses Pre_Hire_Probation_Period_UnitObjectType::setDescriptor()
     * @param \StructType\Pre_Hire_Probation_Period_UnitObjectIDType[] $iD
     * @param string $descriptor
     */
    public function __construct(array $iD = array(), $descriptor = null)
    {
        $this
            ->setID($iD)
            ->setDescriptor($descriptor);
    }
    /**
     * Get ID value
     * @return \StructType\Pre_Hire_Probation_Period_UnitObjectIDType[]|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * This method is responsible for validating the values passed to the setID method
     * This method is willingly generated in order to preserve the one-line inline validation within the setID method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateIDForArrayConstraintsFromSetID(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pre_Hire_Probation_Period_UnitObjectTypeIDItem) {
            // validation for constraint: itemType
            if (!$pre_Hire_Probation_Period_UnitObjectTypeIDItem instanceof \StructType\Pre_Hire_Probation_Period_UnitObjectIDType) {
                $invalidValues[] = is_object($pre_Hire_Probation_Period_UnitObjectTypeIDItem) ? get_class($pre_Hire_Probation_Period_UnitObjectTypeIDItem) : sprintf('%s(%s)', gettype($pre_Hire_Probation_Period_UnitObjectTypeIDItem), var_export($pre_Hire_Probation_Period_UnitObjectTypeIDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ID property can only contain items of type \StructType\Pre_Hire_Probation_Period_UnitObjectIDType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ID value
     * @throws \InvalidArgumentException
     * @param \StructType\Pre_Hire_Probation_Period_UnitObjectIDType[] $iD
     * @return \StructType\Pre_Hire_Probation_Period_UnitObjectType
     */
    public function setID(array $iD = array())
    {
        // validation for constraint: array
        if ('' !== ($iDArrayErrorMessage = self::validateIDForArrayConstraintsFromSetID($iD))) {
            throw new \InvalidArgumentException($iDArrayErrorMessage, __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Add item to ID value
     * @throws \InvalidArgumentException
     * @param \StructType\Pre_Hire_Probation_Period_UnitObjectIDType $item
     * @return \StructType\Pre_Hire_Probation_Period_UnitObjectType
     */
    public function addToID(\StructType\Pre_Hire_Probation_Period_UnitObjectIDType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Pre_Hire_Probation_Period_UnitObjectIDType) {
            throw new \InvalidArgumentException(sprintf('The ID property can only contain items of type \StructType\Pre_Hire_Probation_Period_UnitObjectIDType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ID[] = $item;
        return $this;
    }
    /**
     * Get Descriptor value
     * @return string|null
     */
    public function getDescriptor()
    {
        return $this->Descriptor;
    }
    /**
     * Set Descriptor value
     * @param string $descriptor
     * @return \StructType\Pre_Hire_Probation_Period_UnitObjectType
     */
    public function setDescriptor($descriptor = null)
    {
        // validation for constraint: string
        if (!is_null($descriptor) && !is_string($descriptor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($descriptor, true), gettype($descriptor)), __LINE__);
        }
        $this->Descriptor = $descriptor;
        return $this;
    }
}
